//
//  YHResignAppointContainerViewController.swift
//  galaxy
//
//  Created by edy on 2024/10/11.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHResignAppointContainerViewController: YHBaseViewController {

    var renewalId: Int = 0
    let viewModel = YHResignAppointViewModel()
    
    lazy var appointVC: YHResignAppointTimeViewController = {
        let vc = YHResignAppointTimeViewController()
        vc.view.isHidden = true
        return vc
    }()
    
    lazy var scheduleVC: YHResignAppointSubmitScheduleViewController = {
        let vc = YHResignAppointSubmitScheduleViewController()
        vc.view.isHidden = true
        return vc
    }()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.addChild(appointVC)
        self.addChild(scheduleVC)
        
        self.view.addSubview(appointVC.view)
        self.view.addSubview(scheduleVC.view)
        
        requestData()
    }
    
    func requestData() {
        
        YHHUD.show(.progress(message: "加载中..."))
        viewModel.getAppointInfoList(renewalId: renewalId) {
            [weak self] success, error in
            YHHUD.hide()
            guard let self = self else { return }
            if self.viewModel.appointInfoListModel.renewal_List.count <= 0 { // 没有预约过
                // 请求预约人员列表
                YHHUD.show(.progress(message: "加载中..."))
                self.viewModel.getResignAppointUserlist(renewalId: self.renewalId) {
                    [weak self] success, error in
                    YHHUD.hide()
                    guard let self = self else { return }
                    self.appointVC.allAppointUsers = self.viewModel.appointUsers
                    self.appointVC.updateUI()
                    self.appointVC.view.isHidden = false
                    self.scheduleVC.view.isHidden = true
                }
                
            } else { // 预约过
                self.scheduleVC.view.isHidden = false
                self.appointVC.view.isHidden = true
            }
        }
    }
}
