//
//  YHResignAppointedScheduleSingleItemView.swift
//  galaxy
//
//  Created by edy on 2024/10/11.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHResignAppointedScheduleSingleItemView: UIView {

    lazy var lineView: UIView = {
        let view = UIView()
        view.backgroundColor = .separatorColor
        return view
    }()
    
    lazy var applicantNamesLabel: UILabel = {
        let label = UILabel()
        label.font = UIFont.PFSC_M(ofSize: 14)
        label.textColor = .mainTextColor
        label.text = "申请人："
        return label
    }()
    
    lazy var confirmInHKLabel: UILabel = {
        let label = UILabel()
        label.text = "已确认在港"
        label.font = UIFont.PFSC_M(ofSize: 13)
        label.textColor = .init(hex: 0x3CC694)
        return label
    }()
    
    lazy var confirmInHKBtn: UIButton = {
        let btn = UIButton()
        btn.layer.cornerRadius = 2.0
        btn.backgroundColor = .brandMainColor
        btn.setTitleColor(.white, for: .normal)
        btn.setTitle("确认在港", for: .normal)
        btn.titleLabel?.font = .PFSC_M(ofSize: 11)
        return btn
    }()
    
    lazy var submitTimeLabel: UILabel = {
        let label = UILabel()
        label.font = UIFont.PFSC_R(ofSize: 12)
        label.textColor = .mainTextColor(alpha: 0.5)
        label.text = "预约递交时间: 0000-00-00  00:00"
        return label
    }()
    
    lazy var confirmHKTimeLabel: UILabel = {
        let label = UILabel()
        label.font = UIFont.PFSC_R(ofSize: 12)
        label.textColor = .mainTextColor(alpha: 0.5)
        label.text = "确认在港时间: 0000-00-00  00:00"
        return label
    }()
    
    lazy var scheduleView: YHResignAppointedScheduleLineView = {
        let view = YHResignAppointedScheduleLineView(frame: .zero)
        return view
    }()
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        createUI()
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func createUI() {
        self.addSubview(lineView)
        self.addSubview(applicantNamesLabel)
        self.addSubview(confirmInHKBtn)
        self.addSubview(confirmInHKLabel)
        self.addSubview(confirmHKTimeLabel)
        self.addSubview(submitTimeLabel)
        self.addSubview(confirmHKTimeLabel)
        self.addSubview(scheduleView)

        lineView.snp.makeConstraints { make in
            make.left.right.top.equalToSuperview()
            make.height.equalTo(0.5)
        }
        
        applicantNamesLabel.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.right.equalTo(-18)
            make.top.equalTo(lineView.snp.bottom).offset(18)
        }
        
        confirmInHKBtn.snp.makeConstraints { make in
            make.right.equalTo(-18)
            make.width.equalTo(68)
            make.height.equalTo(28)
            make.centerY.equalTo(applicantNamesLabel)
        }
        
        confirmInHKLabel.snp.makeConstraints { make in
            make.right.equalTo(-18)
            make.top.equalTo(applicantNamesLabel)
            make.height.equalTo(18)
        }
        
        submitTimeLabel.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.right.equalTo(-18)
            make.top.equalTo(applicantNamesLabel.snp.bottom).offset(8)

        }
        
        confirmHKTimeLabel.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.right.equalTo(-18)
            make.top.equalTo(submitTimeLabel.snp.bottom).offset(8)
        }
        
        scheduleView.snp.makeConstraints { make in
            make.left.equalTo(18)
            make.right.equalTo(-18)
            make.top.equalTo(confirmHKTimeLabel.snp.bottom).offset(18)
            make.height.equalTo(84.0)
            make.bottom.equalTo(-18)
        }
    }
}
