//
//  YHResignHaveAppointedInfoCellTableViewCell.swift
//  galaxy
//
//  Created by edy on 2024/10/10.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHResignHaveAppointedMultipleInfoCell: UITableViewCell {

    static let cellReuseIdentifier = "YHResignHaveAppointedMultipleInfoCell"
    
    lazy var whiteContentView: UIView = {
        let view = UIView()
        view.backgroundColor = .white
        view.layer.cornerRadius = kCornerRadius6
        return view
    }()
    
    lazy var titleLabel: UILabel = {
        let label = UILabel()
        label.numberOfLines = 0
        label.font = UIFont.PFSC_M(ofSize: 17)
        label.textColor = .mainTextColor
        label.text = "赴港递交已预约"
        return label
    }()
    
    lazy var modifyBtn: UIButton = {
        let btn = UIButton()
        btn.setTitle("修改", for: .normal)
        btn.setTitleColor(.brandMainColor, for: .normal)
        btn.titleLabel?.font = .PFSC_M(ofSize: 14)
        return btn
    }()
    
    lazy var batchView: UIView = {
        let view = UIView()
        return view
    }()

    required init?(coder: NSCoder) {
        super.init(coder: coder)
    }
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        setupUI()
    }
    
    func setupUI() {
        self.selectionStyle = .none
        self.backgroundColor = .clear
        self.contentView.backgroundColor = .clear
        contentView.addSubview(whiteContentView)
        whiteContentView.addSubview(titleLabel)
        whiteContentView.addSubview(modifyBtn)
        whiteContentView.addSubview(batchView)
        
        whiteContentView.snp.makeConstraints { make in
            make.top.equalTo(0)
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.bottom.equalTo(-16)
        }
        
        titleLabel.snp.makeConstraints { make in
            make.top.equalTo(16)
            make.left.equalTo(18)
            make.right.equalTo(-18)
            make.height.equalTo(24)
        }
        
        modifyBtn.snp.makeConstraints { make in
            make.width.equalTo(28)
            make.height.equalTo(24)
            make.right.equalTo(-18)
            make.centerY.equalTo(titleLabel)
        }
        
        batchView.snp.makeConstraints { make in
            make.left.equalTo(0)
            make.right.equalTo(0)
            make.bottom.equalTo(0)
            make.top.equalTo(titleLabel.snp.bottom).offset(12)
        }
        
        updateUI()
    }
    
    func updateUI() {
        
        let arr = ["", ""]
        batchView.removeSubviews()
        var lastView: YHResignAppointedScheduleMultipleItemView? = nil
        for (index, model) in arr.enumerated() {
            let itemView = YHResignAppointedScheduleMultipleItemView(frame: .zero)
            batchView.addSubview(itemView)
            itemView.snp.makeConstraints { make in
                make.left.equalTo(0)
                make.right.equalTo(0)
                if index == 0 {
                    make.top.equalTo(0)
                } else {
                    if let lastView = lastView {
                        make.top.equalTo(lastView.snp.bottom)
                    }
                }
                
                if index == arr.count - 1 {
                    make.bottom.equalTo(0)
                }
                lastView = itemView
            }
        }
    }
}
